open Ast

module StringMap = Map.Make(String)

type methodSignature = {
  formalAccess: access_modifier;
  formalName : string;
  formalTyps: typ list;
  formalTyp: typ;
}

type classMap = {
  mutable fieldMap: Ast.vdecl StringMap.t;
  mutable constructorMap: methodSignature StringMap.t;
  mutable methodMap:  methodSignature StringMap.t;
}

type classEnv = {
  mutable className: string;
  mutable classMaps: classMap StringMap.t;
  mutable classMap: classMap;
  builtinMethods: string list;
}

type env = {
  mutable envClassName: string;
  mutable envClassMaps: classMap StringMap.t;
  mutable envClassMap: classMap;
  mutable envLocals: typ StringMap.t;
  mutable envParams: typ StringMap.t;
  mutable envReturnType: typ;
  envBuiltinMethods: string list;
}